import net.sergeych.merge3.MergeResult
import net.sergeych.merge3.MergedBlock
import net.sergeych.merge3.merge3
//import net.sergeych.mp_logger.Log
//import net.sergeych.sprintf.sprintf
import kotlin.test.Test
import kotlin.test.assertEquals
import kotlin.test.assertTrue

val List<Char>.str: String get() = joinToString("")

//    fun <T>MergeResult<T>.toTrace(source: List<T>): String {
//        val r = StringBuilder()
//        r.append(merged.indices.joinToString("") { "%3d".sprintf(it) } + "\n")
//        r.append(merged.joinToString("") { "%3s".sprintf(it) } + "\n")
//        r.append("---- source ----\n")
//        r.append(source.joinToString("") { "%3s".sprintf(it) } + "\n")
//        r.append(sourceIndices.joinToString("") { "%3s".sprintf(it) } + "\n")
//        return r.toString()
//    }

class BasicTest {
    @Test
    fun testMergeNoConflicts() {
        val src = "Hello world".toList()
        val a = "Hello cruel world!".toList()
        val b = "Bye world!!".toList()

        val m = merge3(src, b, a)
//        println(m.merged.str)
//        println(m.conflicts)
//        println(m.changedAreas)
        assertEquals("Bye cruel world!!!", m.merged.str)
//        assertTrue(m.noConflicts)
    }
    @Test
    fun testMergeNoConflicts3() {
// Log.connectConsole()
        val src = "Hello, world!".toList()
        val a = "Hello, friend!".toList()
        val b = "Bye world!".toList()

        val m = merge3(src, a, b)
//        println(m.merged.str)
//        println(m.conflicts)
//        println(m.changedAreas)
        assertEquals("Bye friend!", m.merged.str)
//        println(m.toTrace(src))
//        assertTrue(m.noConflicts)
    }

    @Test
    fun testMergeNoConflicts2() {
        val src = "Hello world".toList()
        val a = "Hello friend".toList()
        val b = "Bye world".toList()

        val m = merge3(src, b, a)
//        println(m.merged.str)
//        println(m.conflicts)
//        println(m.changedAreas)
        assertEquals("Bye friend", m.merged.str)
//        assertTrue(m.noConflicts)
//        println(m.blocks)
    }
    @Test
    fun testMergeWithConflicts() {
// Log.connectConsole()
        val src = "Hello world".toList()
        val a = "Hello 123".toList()
        val b = "Hello 456".toList()

        val m = merge3(src, b, a)
//        println(m.merged.str)
//        println(m.conflicts)
//        println(m.changedAreas)
        assertEquals("Hello 456123", m.merged.str)
    }

    @Test
    fun testMergeIndexes() {
// Log.connectConsole()
        val src = "Hello".toList()
        val a = "123 Hello".toList()
        val b = "456 Hello".toList()

        val m = merge3(src, b, a)
//        println(m.toTrace(src))
//        println(m.changedAreas)
//        for( b in m.blocks )
//            println(b)
        val unchanged = m.blocks.last() as MergedBlock.Unchanged
//        println(unchanged)
        assertEquals(0, unchanged.referenceIndex)
    }

    @Test
    fun testMergeIndexes2() {
// Log.connectConsole()
        val src = "Hello".toList()
        val a = "1Hello".toList()
        val b = "2Hello".toList()

        val m = merge3(src, b, a)
        val unchanged = m.blocks.last() as MergedBlock.Unchanged
//        println(unchanged)
        assertEquals(0, unchanged.referenceIndex)
    }

    @Test
    fun testMergeFilter() {
// Log.connectConsole()
        val source = "lxcvv".toList()
        val our = "lssdfasdwerwev".toList()
        val their = "lxcvasdfasdfs".toList()
        val result = merge3(source, their, our)
//        println("got result: ${result.toTrace(source)}")
//        println("got result: ${result.blocks}")
        result.blocks.filter { it is MergedBlock.Unchanged }
        assertTrue(true)
    }

    @Test
    fun testMergeEmpty() {
// Log.connectConsole()
        val source = "".toList()
        val our = "".toList()
        val their = "".toList()
        val result = merge3(source, their, our)
//        println("got result: ${result.toTrace(source)}")
//        println("got result: ${result.blocks}")
        result.blocks.filter { it is MergedBlock.Unchanged }
        assertTrue(true)
    }

    @Test
    fun testMergeUnchanged1() {
        val source = "abc".toList()
        val their = "abcDEF".toList()
        val our = "abcDEF".toList()

        val result = merge3(source, their, our)
//        println(result.merged.str)
//        println(result.blocks)
        assertEquals("abcDEF", result.merged.str)
    }

    @Test
    fun testMergePartial1() {
        val source = "abc".toList()
        val their = "abcDEF1".toList()
        val our = "abcDEF".toList()

        val result = merge3(source, their, our)
//        println(result.merged.str)
//        println(result.blocks)
        assertEquals("abcDEF1", result.merged.str)
    }

    @Test
    fun testMergePartial2() {
        val source = "abc".toList()
        val their = "abcDEF".toList()
        val our = "abcDEF1".toList()

        val result = merge3(source, their, our)
//        println(result.merged.str)
//        println(result.blocks)
        assertEquals("abcDEF1", result.merged.str)
    }

    @Test
    fun testMergeConflictOrder1() {
// Log.connectConsole()
        val source = "abc".toList()
        val their = "abcDEF".toList()
        val our = "abcGHY".toList()

        val result = merge3(source, their, our)
//        println(result.merged.str)
//        println(result.blocks)
        // the order is unexpected:
        assertTrue { result.merged.str in listOf("abcDEFGHY", "abcGHYDEF") }
    }

    @Test
    fun testMergeConflictOrder2() {
        val source = "ABAB".toList()
        val our = "ACAC".toList()
        val their = "ADAD".toList()

        val result = merge3(source, their, our)
//        println(result.merged.str)
        // The order is undetermied:
        assertTrue(result.merged.str in listOf("ACDADC", "ADCACD", "ADCADC", "ACDACD"))
    }
}